<script lang="ts">
    import { histogram, numberOfBins } from '../histogram'
    import { svgCoordinate, svgdraggable } from '../graph/drag'
    import { threshold } from '../data'

    const svgWidth = 300
    const svgHeight = 120
    const textHeight = 28
    const thumbRadius = 10
    const svgPadding = thumbRadius + 2

    const barWidth = (svgWidth - 2 * svgPadding) / numberOfBins
    const barPadding = 2

    const yTrack = svgHeight - textHeight - svgPadding

    $: heightScale = (yTrack - barPadding) / Math.max(...$histogram.bins, 8)
    $: bins = $histogram.bins.map((count, i) => ({
        count: count,
        height: count > 0 ? Math.max(count * heightScale, 3) : 0,
        x: svgPadding + i * barWidth
    }))

    $: $threshold = $histogram.min
    $: xThumb = ($threshold - $histogram.min) / ($histogram.max - $histogram.min) * (svgWidth - 2 * svgPadding) + svgPadding

    function move(x: number) {
        const min = $histogram.min
        const max = $histogram.max
        const i = (x - svgPadding) / (svgWidth - 2 * svgPadding) // 0 .. 1
        const value = i * (max - min) + min // min .. max
        $threshold = Math.max(min, Math.min(value, max - 0.1)) // clamped between min .. max - 0.1
    }
</script>

<svg viewBox="0 0 {svgWidth} {svgHeight}" width={svgWidth} height={svgHeight}
     on:click={(e) => move(svgCoordinate(e, e.target).x)}>

    {#each bins as bin, i}
        <rect x={bin.x + barPadding} width={barWidth - barPadding * 2}
              y={yTrack - bin.height } height={bin.height}
              class:below={bin.x + barWidth < xThumb}
        ></rect>
    {/each}

    <rect x={svgPadding} width={xThumb - svgPadding} y={yTrack} height="1" class="below"></rect>
    <rect x={xThumb} width={svgWidth - svgPadding - xThumb} y={yTrack} height="1"></rect>

    <circle r={thumbRadius} cx={xThumb} cy={yTrack} class="fill-donkerblauw"
            use:svgdraggable on:svgdragmove={(e) => move(e.detail.x)}
    ></circle>

    <text x={svgPadding} y={svgHeight - svgPadding}>Link threshold</text>
    <text x={svgWidth - svgPadding} y={svgHeight - svgPadding} text-anchor="end">{$threshold.toFixed(1)}</text>
</svg>


<style>
    rect {
        @apply stroke-2 stroke-donkerblauw fill-donkerblauw-1;
    }

    rect.below {
        @apply stroke-grijs-5 fill-grijs-2
    }
</style>